package submit10_kari;

import java.io.*;
import java.security.SecureRandom;
import java.util.*;

import sun.reflect.ReflectionFactory.GetReflectionFactoryAction;
import static java.lang.Math.*;
import static java.lang.Integer.*;


/*

 */


public class RectanglesAndHoles {

	static PrintStream err = System.err;
	static long progtime = 0;
	
	static int N = 0;
	Random rnd = new Random();
	static boolean debug = true;
	
	static int stackThreshold = 3;
	
	
    public static final int UNKNOWN = -1;
    public static final int OBSTACLE = -2;
	
	static void debug(String s){
		if(debug){
			err.print(s);
		}
	}
	static void debug(int i){
		if(debug){
			err.print(i);
		}
	}
	static void debug(long i){
		if(debug){
			err.print(i);
		}
	}
	
	List<R> rs = null;


	
	public int[] place(int[] A, int[] B){
		long start =  System.currentTimeMillis();


		int[] ret = null;
		N = A.length;

		List<R> orgs = new ArrayList<R>();
		rs = new ArrayList<R>();
		
		long maxscore = 0;
		List<R> defaultRs = new ArrayList<R>();
		try{
			for(int i = 0; i < N; i++){
				R r = new R(A[i], B[i]);
				r.idx = i;
				
				defaultRs.add(r);
				orgs.add(r);
			}
			
			// 
			Collections.sort(defaultRs, new Comparator<R>() {
				@Override
				public int compare(R o1, R o2) {
					return o1.l - o2.l;
				}
			});
			for(int addcnt = 8; addcnt < N / 2; addcnt+=8){
				rs = new ArrayList<R>();
				for(int i = 0; i < defaultRs.size(); i++){
					rs.add(defaultRs.get(i));
				}
				mycalcNew2(addcnt);
				long curscore = score(orgs);
				if(curscore > maxscore){
					maxscore = curscore;
					ret = new int[N*3];
					for(int i = 0; i < N; i++){
						R r = orgs.get(i);
						ret[3*i] = r.lx;
						ret[3*i+1] = r.ly;
						ret[3*i+2] = r.d;
					}
				}
				
				progtime = System.currentTimeMillis() - start;
				if(progtime >= 7000){
					break;
				}
			}
		}
		catch(Exception ex){
			err.println(ex.getMessage());
		}
		
		progtime += System.currentTimeMillis() - start;
		//debug(progtime);
		return ret;
	}
	
	private void mycalcNew2(int additionalNum) throws Exception{
		
		
		// ꉞŏɑSɂ
		for(R r : rs){
			r.yokonaga();
		}
		
		List<R> forcheck = new ArrayList<R>();
	
		List<Line> lineList = new ArrayList<Line>();
		List<R> forlast = new ArrayList<R>();
		forlast.add(getFirst());
		forlast.add(getFirst());
		
		List<R> additionals = new ArrayList<R>();
		for(int i = 0; i < additionalNum; i++){
			additionals.add(getFirst());
		}
		
		
		for(int i = 0; i < 4; i++){
			Line line = new Line();
			R r = rs.remove(0);
			
			R first = getFirst();
			first.set(0, 0);
			line.lines.add(first);
			int ly = first.ry;
			int lx = first.rx;

			
			r.set(ly, lx);
			line.lines.add(r);
			line.last = r;
			lineList.add(line);
		}
		
		
		
		
		while(rs.size() > 0){
			int nextidx = getNextIdx(lineList);
			addToLine(lineList.get(nextidx));
		}
		
		
		Collections.sort(lineList, new Comparator<Line>() {
			@Override
			public int compare(Line o1, Line o2) {
				return len(o1) - len(o2);
			}
		});
		
		List<List<R>> addList = createAdditionals(additionals);
		
		for(Line line : lineList){
			List<R> rs = addList.remove(0);
			List<R> ls = addList.remove(0);
			
			while(rs.size() > 0){
				R r = rs.remove(rs.size()-1);
				R l = ls.remove(ls.size()-1);
				int[] leftdown = getLeftDown(line.lines);
				int[] rightdown = getRightDown(line.lines);
				int ly, lx;
				ly = leftdown[0] - l.ta;
				lx = leftdown[1] - l.yo;
				l.set(ly, lx);
				ly = rightdown[0] - r.ta;
				lx = rightdown[1];
				r.set(ly, lx);
				line.lines.add(l);
				line.lines.add(r);
			}
		}

		
		Collections.sort(lineList, new Comparator<Line>() {
			@Override
			public int compare(Line o1, Line o2) {
				return len(o2) - len(o1);
			}
		});
		
		List<R> left = lineList.get(2).lines;
		rotate(left);
		
		int[] leftDownRight = getDownRight(left);
		
		List<R> down = lineList.get(0).lines;
		{
			rotate(down);
			rotate(down);
			int[] downLeftUp = getLeftUp(down);
			int oy = leftDownRight[0] - downLeftUp[0];
			int ox = leftDownRight[1] - downLeftUp[1];
			move(down, oy, ox);
		}
		List<R> right = lineList.get(1).lines;
		{
			rotate(right);
			rotate(right);
			rotate(right);
			int[] rightdownleft = getDownLeft(right);
			int[] downrightup = getRightUp(down);
			int oy = downrightup[0] - rightdownleft[0];
			int ox = downrightup[1] - rightdownleft[1];
			move(right, oy, ox);
		}
		List<R> up = lineList.get(3).lines;
		{
			int[] leftupright = getUpRight(left);
			int[] upleftdown = getLeftDown(up);
			int oy = leftupright[0] - upleftdown[0];
			int ox = leftupright[1] - upleftdown[1];
			move(up, oy, ox);
		}
		
		forcheck.addAll(up);
		forcheck.addAll(down);
		forcheck.addAll(left);
		forcheck.addAll(right);
		
		R last1 = forlast.get(0);
		R last2 = forlast.get(1);
		
		
		last2.set(30000, 30000);
		
		int[] upRightUp = getRightUp(up);
		last1.set(upRightUp[0], upRightUp[1]);
		
		
		
		int prevCnt = test(forcheck);
		connect(forcheck, up, right, last1);
		int nowCnt = test(forcheck);
		if(prevCnt == nowCnt){
			connect(forcheck, up, right, last2);
		}
		else{
			//debug("last2 sute \n");
			int[] tpos = getRightUp(forcheck);
			int ly = tpos[0] + 1000;
			int lx = tpos[1] + 1000;
			last2.set(ly, lx);
		}
	}
	

	
//	private void mycalc() throws Exception{
//		
//		
//		// ꉞŏɑSɂ
//		for(R r : rs){
//			r.yokonaga();
//		}
//		
//		List<R> forcheck = new ArrayList<R>();
//	
//		List<Line> lineList = new ArrayList<Line>();
//		List<R> forlast = new ArrayList<R>();
//		forlast.add(getFirst());
//		forlast.add(getFirst());
//		
//		List<R> additionals = new ArrayList<R>();
//		for(int i = 0; i < 8; i++){
//			additionals.add(getFirst());
//		}
//		
//		
//		for(int i = 0; i < 4; i++){
//			Line line = new Line();
//			R r = rs.remove(0);
//			
//			R first = getFirst();
//			first.set(0, 0);
//			line.lines.add(first);
//			int ly = first.ry;
//			int lx = first.rx;
//
//			
//			r.set(ly, lx);
//			line.lines.add(r);
//			line.last = r;
//			lineList.add(line);
//		}
//		
//		
//		
//		
//		while(rs.size() > 0){
//			int nextidx = getNextIdx(lineList);
//			addToLine(lineList.get(nextidx));
//		}
//		
//		
//		Collections.sort(lineList, new Comparator<Line>() {
//			@Override
//			public int compare(Line o1, Line o2) {
//				return len(o1) - len(o2);
//			}
//		});
//		for(Line line : lineList){
//			R r = additionals.remove(0);
//			R l = additionals.remove(0);
//			
//			int[] leftdown = getLeftDown(line.lines);
//			int[] rightdown = getRightDown(line.lines);
//			int ly, lx;
//			ly = leftdown[0] - l.ta;
//			lx = leftdown[1] - l.yo;
//			l.set(ly, lx);
//			ly = rightdown[0] - r.ta;
//			lx = rightdown[1];
//			r.set(ly, lx);
//			line.lines.add(l);
//			line.lines.add(r);
//		}
//
//		
//		Collections.sort(lineList, new Comparator<Line>() {
//			@Override
//			public int compare(Line o1, Line o2) {
//				return len(o2) - len(o1);
//			}
//		});
//		
//		List<R> left = lineList.get(2).lines;
//		rotate(left);
//		
//		int[] leftDownRight = getDownRight(left);
//		
//		List<R> down = lineList.get(0).lines;
//		{
//			rotate(down);
//			rotate(down);
//			int[] downLeftUp = getLeftUp(down);
//			int oy = leftDownRight[0] - downLeftUp[0];
//			int ox = leftDownRight[1] - downLeftUp[1];
//			move(down, oy, ox);
//		}
//		List<R> right = lineList.get(1).lines;
//		{
//			rotate(right);
//			rotate(right);
//			rotate(right);
//			int[] rightdownleft = getDownLeft(right);
//			int[] downrightup = getRightUp(down);
//			int oy = downrightup[0] - rightdownleft[0];
//			int ox = downrightup[1] - rightdownleft[1];
//			move(right, oy, ox);
//		}
//		List<R> up = lineList.get(3).lines;
//		{
//			int[] leftupright = getUpRight(left);
//			int[] upleftdown = getLeftDown(up);
//			int oy = leftupright[0] - upleftdown[0];
//			int ox = leftupright[1] - upleftdown[1];
//			move(up, oy, ox);
//		}
//		
//		forcheck.addAll(up);
//		forcheck.addAll(down);
//		forcheck.addAll(left);
//		forcheck.addAll(right);
//		
//		R last1 = forlast.get(0);
//		R last2 = forlast.get(1);
//		
//		
//		last2.set(30000, 30000);
//		
//		int[] upRightUp = getRightUp(up);
//		last1.set(upRightUp[0], upRightUp[1]);
//		
//		
//		
//		int prevCnt = test(forcheck);
//		connect(forcheck, up, right, last1);
//		int nowCnt = test(forcheck);
//		if(prevCnt == nowCnt){
//			connect(forcheck, up, right, last2);
//		}
//		else{
//			//debug("last2 sute \n");
//			int[] tpos = getRightUp(forcheck);
//			int ly = tpos[0] + 1000;
//			int lx = tpos[1] + 1000;
//			last2.set(ly, lx);
//		}
//	}
	
	List<List<R>> createAdditionals(List<R> list){
		List<List<R>> ret = new ArrayList<List<R>>();
		for(int i = 0; i < 8; i++){
			ret.add(new ArrayList<R>());
		}
		Collections.sort(list, new Comparator<R>() {
			@Override
			public int compare(R o1, R o2) {
				return o2.s - o1.s;
			}
		});
		

		while(list.size() > 0){
			for(int i = 0; i < 8; i++){
				ret.get(i).add(list.remove(0));
			}
			Collections.sort(ret, new Comparator<List<R>>() {
				@Override
				public int compare(List<R> o1, List<R> o2) {
					int sum1 = 0;
					int sum2 = 0;
					for(R r : o1){
						sum1 += r.s;
					}
					for(R r : o2){
						sum2 += r.s;
					}
					return sum1 - sum2;
				}
			});
		}
		
		return ret;
	}
	
	
	
	void connect(List<R> forcheck, List<R> up, List<R> right, R r){

		int[] rightTopLeft = getUpLeft(right);
		int[] uprightup = getRightUp(up);
		int[] upRightYs = getRightY(up, uprightup[1]);
		int ly, lx;
		if(upRightYs[0] - r.ta > rightTopLeft[0]){
			ly = upRightYs[0] - r.ta;
			lx = Math.min(uprightup[1], rightTopLeft[1] - r.yo);
			r.set(ly, lx);
			forcheck.add(r);
		}
		else if(upRightYs[1] > rightTopLeft[0] ){
			ly = rightTopLeft[0];
			lx = uprightup[1];
			
			r.set(ly, lx);
			forcheck.add(r);
		}
		else{
			ly = uprightup[0];
			if(rightTopLeft[1] - uprightup[1] > r.yo){
				lx = uprightup[1];
			}
			else{
				lx = rightTopLeft[1] - r.yo;
			}
			r.set(ly, lx);
			forcheck.add(r);
		}
		up.add(r);
	}
	
	int[] getRightY(List<R> lines, int tx){
		int[] ret = new int[2];
		ret[0] = Integer.MAX_VALUE;
		ret[1] = Integer.MIN_VALUE;
		for(R r : lines){
			if(r.rx == tx){
				ret[0] = Math.min(ret[0], r.ly);
				ret[1] = Math.max(ret[1], r.ry);
			}
		}
		return ret;
	}
	
	int getLeftX(List<R> lines, int ly, int ry){
		int ret = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.ly <= ly && ly <= r.ry || r.ly <= ry && ry <= r.ry ||
					ly <= r.ly && r.ly <= ry || ly <= r.ry && r.ry <= ry ){
				ret = Math.min(ret, r.lx);
			}
		}
		return ret;
	}
	
	int[] getRightUp(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MIN_VALUE;
		for(R r : lines){
			if(r.rx > ret[1]){
				ret[1] = r.rx;
				ret[0] = r.ry;
			}
			else if(r.rx == ret[1]){
				ret[0] = Math.max(ret[0], r.ry);
			}
		}
		return ret;
	}
	
	int[] getRightDown(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MIN_VALUE;
		for(R r : lines){
			if(r.rx > ret[1]){
				ret[1] = r.rx;
				ret[0] = r.ly;
			}
			else if(r.rx == ret[1]){
				ret[0] = Math.min(ret[0], r.ly);
			}
		}
		return ret;
	}
	
	int[] getDownLeft(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MAX_VALUE;
		ret[1] = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.ly < ret[0]){
				ret[0] = r.ly;
				ret[1] = r.lx;
			}
			else if(r.ly == ret[0]){
				ret[1] = Math.min(ret[1], r.lx);
			}
		}
		
		return ret;
	}
	
	//ԍ̏
	int[] getLeftUp(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.lx < ret[1]){
				ret[1] = r.lx;
				ret[0] = r.ry;
			}
			else if(r.lx == ret[1]){
				ret[0] = Math.max(ret[0], r.ry);
			}
		}
		return ret;
	}
	
	int[] getLeftDown(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.lx < ret[1]){
				ret[1] = r.lx;
				ret[0] = r.ly;
			}
			else if(r.lx == ret[1]){
				ret[0] = Math.min(ret[0], r.ly);
			}
		}
		return ret;
	}
	
	int[] getUpRight(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MIN_VALUE;
		for(R r : lines){
			if(r.ry > ret[0]){
				ret[0] = r.ry;
				ret[1] = r.rx;
			}
			else if(r.ry == ret[0]){
				ret[1] = Math.max(ret[1], r.rx);
			}
		}
		return ret;
	}
	
	int[] getUpLeft(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MIN_VALUE;
		ret[1] = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.ry > ret[0]){
				ret[0] = r.ry;
				ret[1] = r.lx;
			}
			else if(r.ry == ret[0]){
				ret[1] = Math.min(ret[1], r.lx);
			}
		}
		return ret;
	}
	
	int[] getDownRight(List<R> lines){
		int[] ret = new int[2];
		ret[0] = Integer.MAX_VALUE;
		ret[1] = Integer.MAX_VALUE;
		for(R r : lines){
			if(r.ly < ret[0]){
				ret[0] = r.ly;
				ret[1] = r.rx;
			}
			else if(r.ly == ret[0]){
				ret[1] = Math.max(ret[1], r.rx);
			}
		}
		return ret;
	}
	
	int getNextIdx(List<Line> lineList){
		int[] lens = new int[4];
		int min = Integer.MAX_VALUE;
		for(int i = 0; i < 4; i++){
			lens[i] = len(lineList.get(i));
			min = Math.min(min, lens[i]);
		}
		int nextidx = -1;
		for(int i = 0; i < 4; i++){
			if(lens[i] == min){
				nextidx = i;
				break;
			}
		}
		return nextidx;
	}
	
	void move(List<R> lines, int oy, int ox){
		for(R r : lines){
			r.ly += oy;
			r.lx += ox;
			r.ry += oy;
			r.rx += ox;
		}
	}
	
	int len(Line line){
		int lx = Integer.MAX_VALUE;
		int rx = Integer.MIN_VALUE;
		for(R r : line.lines){
			lx = Math.min(lx, r.lx);
			rx = Math.max(rx, r.rx);
		}
		
		return rx - lx;
	}
	
	void addToLine(Line line){
		if(rs.size() >= stackThreshold){
			R r1, r2, r3;
			r1 = r2 = r3 = null;
			
			r1 = rs.remove(0);
			r2 = rs.remove(0);
			r3 = rs.remove(0);
			
			List<R> lines = line.lines;
			List<R> ups1 = line.ups1;
			List<R> ups2 = line.ups2;
			R last = line.last;
			
			int holeCnt = line.holeCnt;
			
			{// r1
				int ly = last.ly - r1.ta;
				int lx = last.rx;
				r1.set(ly, lx);
			}
			{// r3
				int ly = r1.ry;
				int lx = r1.rx;
				r3.set(ly, lx);
			}
			{// r2
				int ly = 0;
				int lx = 0;
				if(last.ry <= r3.ry){
					ly = last.ry;
					lx = r3.lx - r2.yo;
				}
				else{
					ly = r3.ry;
					lx = last.rx;
				}
				
				r2.set(ly, lx);
			}
			lines.add(r1);
			lines.add(r2);
			lines.add(r3);
			
			int newCnt = test(lines);
			if(newCnt < 0){
				debug("fukuda kokokuru 2dame");
				int ly = r3.ly;
				int lx = r3.lx;
				lines.remove(r3);
				rs.add(r3);
				r2.set(ly, lx);
				r3 = r2; // lastɎw肷邽
			}
			else if(rs.size() > 0){
				holeCnt = newCnt;
				ups1.add(r2);
				
				if(ups1.size() >= 2){
					int newcnt = 0;
					R r = null;
					{
						R rl = ups1.get(ups1.size()-2);
						R rr = ups1.get(ups1.size()-1);
						r = rs.remove(0);
						if(r.idx == 14 || r.idx == 45){
							err.print("");
						}
						int ly, lx;
						if(rl.ry >= rr.ry){
							ly = rr.ry;
							lx = rl.rx;
						}
						else{
							ly = rl.ry;
							lx = rr.lx - r.yo;
						}
						r.set(ly, lx);
						lines.add(r);
						newcnt = test(lines);
					}
					if(newcnt <= holeCnt){
						//߂
						lines.remove(r);
						rs.add(0, r);
					}
					else if(rs.size() > 0){
						holeCnt = newcnt;
						ups2.add(r);
						
						if(ups2.size() >= 2){
							R rl = ups2.get(ups2.size()-2);
							R rr = ups2.get(ups2.size()-1);
							r = rs.remove(0);
							if(r.idx == 14 || r.idx == 45){
								err.print("");
							}
							int ly, lx;
							if(rl.ry >= rr.ry){
								ly = rr.ry;
								lx = rl.rx;
							}
							else{
								ly = rl.ry;
								lx = rr.lx - r.yo;
							}
							r.set(ly, lx);
							lines.add(r);
							newcnt = test(lines);
							if(newcnt <= holeCnt){
								//߂
								lines.remove(r);
								rs.add(0, r);
							}
							else{
								holeCnt = newcnt;
							}
						}
					}
				}
			}
	
			line.last = r3;
			line.holeCnt = holeCnt;
		}
		else{
			R r = rs.remove(0);
			int ly = line.last.ly;
			int lx = line.last.rx;
			r.set(ly, lx);
			line.lines.add(r);
			line.last = r;
		}
	}
	
	class Line{
		List<R> lines = new ArrayList<R>();
		List<R> ups1 = new ArrayList<R>();
		List<R> ups2 = new ArrayList<R>();
		R last = null;
		int holeCnt = 0;
	}
	
	void rotate(List<R> lines){
		for(R r : lines){
			
			int nly = r.ly + r.ta;
			int nlx = r.lx;
			
			r.r();
			
			int ty = nly;
			r.ly = nlx;
			r.lx = -ty;
			
			r.ry = r.ly + r.ta;
			r.rx = r.lx + r.yo;
		}
	}
	
	public int test(List<R> lines) {
        int N = lines.size();

        int[] ret = new int[N*3];
        int[] A = new int[N];
        int[] B = new int[N];
		for(int i = 0; i < N; i++){
			R r = lines.get(i);
			A[i] = r.a;
			B[i] = r.b;
			ret[3*i] = r.lx;
			ret[3*i+1] = r.ly;
			ret[3*i+2] = r.d;
		}

        int[] LX = new int[N];
        int[] LY = new int[N];
        int[] RX = new int[N];
        int[] RY = new int[N];

        int[] kind = new int[N];

        for (int i=0; i < N; i++) {
            LX[i] = ret[i*3];
            LY[i] = ret[i*3+1];
            kind[i] = ret[i*3+2];
        }


        for (int i=0; i < N; i++) {
            
            RX[i] = LX[i] + (kind[i] == 0 ? A[i] : B[i]);
            RY[i] = LY[i] + (kind[i] == 0 ? B[i] : A[i]);
        }

        for (int i=0; i < N; i++) {
            for (int j=i+1; j < N; j++) {
                if (overlap(LX[i], RX[i], LX[j], RX[j]) && overlap(LY[i], RY[i], LY[j], RY[j])) {
                    return -1;
                }
            }
        }

        int[] XS = enumerateCoordinates(LX, RX);
        int[] YS = enumerateCoordinates(LY, RY);

        int[][] map = new int[XS.length - 1][YS.length - 1];

        for (int[] elm : map) {
            Arrays.fill(elm, UNKNOWN);
        }

        for (int i=0; i < N; i++) {
            int fromX = Arrays.binarySearch(XS, LX[i]);
            int toX = Arrays.binarySearch(XS, RX[i]);
            int fromY = Arrays.binarySearch(YS, LY[i]);
            int toY = Arrays.binarySearch(YS, RY[i]);

            for (int x=fromX; x < toX; x++) {
                for (int y=fromY; y < toY; y++) {
                    map[x][y] = OBSTACLE;
                }
            }
        }

        int cells = map.length * map[0].length;

        int compCnt = 0;

        int[] QX = new int[cells];
        int[] QY = new int[cells];

        int qBeg = 0, qEnd = 0;

        final int[] DX = new int[] {-1, 1, 0, 0};
        final int[] DY = new int[] {0, 0, -1, 1};

        for (int x=0; x < map.length; x++) {
            for (int y=0; y < map[0].length; y++) {
                if (map[x][y] == UNKNOWN) {
                    QX[qBeg] = x;
                    QY[qBeg++] = y;
                    map[x][y] = compCnt;

                    while (qEnd < qBeg) {
                        int curX = QX[qEnd];
                        int curY = QY[qEnd++];

                        for (int d = 0; d < DX.length; d++) {
                            int nextX = curX + DX[d];
                            int nextY = curY + DY[d];

                            if (nextX >= 0 && nextX < map.length && nextY >= 0 && nextY < map[0].length
                                    && map[nextX][nextY] == UNKNOWN) {
                                QX[qBeg] = nextX;
                                QY[qBeg++] = nextY;
                                map[nextX][nextY] = compCnt;
                            }
                        }
                    }

                    compCnt++;
                }
            }
        }

        long totArea = 0;

        for (int x=0; x < map.length; x++) {
            for (int y=0; y < map[0].length; y++) {
                if (map[x][y] > 0) {
                    totArea += (long)(XS[x + 1] - XS[x]) * (YS[y + 1] - YS[y]);
                }
            }
        }

        compCnt--;
        
        return compCnt;
    }
	
	long score(List<R> lines){
		  int N = lines.size();

        int[] ret = new int[N*3];
        int[] A = new int[N];
        int[] B = new int[N];
		for(int i = 0; i < N; i++){
			R r = lines.get(i);
			A[i] = r.a;
			B[i] = r.b;
			ret[3*i] = r.lx;
			ret[3*i+1] = r.ly;
			ret[3*i+2] = r.d;
		}

        int[] LX = new int[N];
        int[] LY = new int[N];
        int[] RX = new int[N];
        int[] RY = new int[N];

        int[] kind = new int[N];

        for (int i=0; i < N; i++) {
            LX[i] = ret[i*3];
            LY[i] = ret[i*3+1];
            kind[i] = ret[i*3+2];
        }


        for (int i=0; i < N; i++) {
            
            RX[i] = LX[i] + (kind[i] == 0 ? A[i] : B[i]);
            RY[i] = LY[i] + (kind[i] == 0 ? B[i] : A[i]);
        }

        for (int i=0; i < N; i++) {
            for (int j=i+1; j < N; j++) {
                if (overlap(LX[i], RX[i], LX[j], RX[j]) && overlap(LY[i], RY[i], LY[j], RY[j])) {
                    return -1;
                }
            }
        }

        int[] XS = enumerateCoordinates(LX, RX);
        int[] YS = enumerateCoordinates(LY, RY);

        int[][] map = new int[XS.length - 1][YS.length - 1];

        for (int[] elm : map) {
            Arrays.fill(elm, UNKNOWN);
        }

        for (int i=0; i < N; i++) {
            int fromX = Arrays.binarySearch(XS, LX[i]);
            int toX = Arrays.binarySearch(XS, RX[i]);
            int fromY = Arrays.binarySearch(YS, LY[i]);
            int toY = Arrays.binarySearch(YS, RY[i]);

            for (int x=fromX; x < toX; x++) {
                for (int y=fromY; y < toY; y++) {
                    map[x][y] = OBSTACLE;
                }
            }
        }

        int cells = map.length * map[0].length;

        int compCnt = 0;

        int[] QX = new int[cells];
        int[] QY = new int[cells];

        int qBeg = 0, qEnd = 0;

        final int[] DX = new int[] {-1, 1, 0, 0};
        final int[] DY = new int[] {0, 0, -1, 1};

        for (int x=0; x < map.length; x++) {
            for (int y=0; y < map[0].length; y++) {
                if (map[x][y] == UNKNOWN) {
                    QX[qBeg] = x;
                    QY[qBeg++] = y;
                    map[x][y] = compCnt;

                    while (qEnd < qBeg) {
                        int curX = QX[qEnd];
                        int curY = QY[qEnd++];

                        for (int d = 0; d < DX.length; d++) {
                            int nextX = curX + DX[d];
                            int nextY = curY + DY[d];

                            if (nextX >= 0 && nextX < map.length && nextY >= 0 && nextY < map[0].length
                                    && map[nextX][nextY] == UNKNOWN) {
                                QX[qBeg] = nextX;
                                QY[qBeg++] = nextY;
                                map[nextX][nextY] = compCnt;
                            }
                        }
                    }

                    compCnt++;
                }
            }
        }

        long totArea = 0;

        for (int x=0; x < map.length; x++) {
            for (int y=0; y < map[0].length; y++) {
                if (map[x][y] > 0) {
                    totArea += (long)(XS[x + 1] - XS[x]) * (YS[y + 1] - YS[y]);
                }
            }
        }

        compCnt--;
        
        return totArea * compCnt * compCnt;
	}

	
    boolean overlap(int A, int B, int C, int D) {
        return Math.max(A, C) < Math.min(B, D);
    }
	
    int[] enumerateCoordinates(int[] A, int[] B) {
        int min = Integer.MAX_VALUE;
        int max = Integer.MIN_VALUE;

        Set<Integer> coords = new HashSet<Integer>();

        for (int elm : A) {
            min = Math.min(min, elm);
            max = Math.max(max, elm);
            coords.add(elm);
        }

        for (int elm : B) {
            min = Math.min(min, elm);
            max = Math.max(max, elm);
            coords.add(elm);
        }

        coords.add(min - 1);
        coords.add(max + 1);

        int cnt = coords.size();

        int[] res = new int[cnt];

        int pos = 0;
        for (int elm : coords) {
            res[pos++] = elm;
        }

        Arrays.sort(res);

        return res;
    }
	
	
	class G{
		R r1 = null;
		R r2 = null;
		R r3 = null;
	}
	
	R getFirst(){
		List<R> f = new ArrayList<R>();
		for(int i = 0; i < rs.size(); i++ ){
			f.add(rs.get(i));
		}
		Collections.sort(f, new Comparator<R>() {

			@Override
			public int compare(R o1, R o2) {
				return o2.s - o1.s;
			}
			
		});
		R r = f.get(0);
		rs.remove(r);
		return r;
	}
	

	
	
			
	
	class R{
		public R(int a, int b){
			this.a = a;
			this.b = b;
			l = Math.max(a, b);
			s = Math.min(a, b);
			yo = a;
			ta = b;
		}
		
		public void yokonaga(){
			if(b > a && d == 0){
				r();
			}
			if(a > b && d == 1){
				r();
			}
		}
		
		public void tatenaga(){
			if(a > b && d == 0){
				r();
			}
			if(b > a && d == 1){
				r();
			}
		}
		
		void r(){
			if(d == 0){
				d = 1;
				yo = b;
				ta = a;
			}
			else{
				d = 0;
				yo = a;
				ta = b;
			}
		}
		
		public void set(int ly, int lx){
			this.ly = ly;
			this.lx = lx;
			ry = ly + ta;
			rx = lx + yo;
			
		}
		
		int a = 0;
		int b = 0;
		int l = 0;
		int s = 0;
		int ta = 0;
		int yo = 0;
		int idx = 0;
		int ly = 0;
		int lx = 0;
		int ry = 0;
		int rx = 0;
		int d = 0;
	}
}
